diff -U 3 -H -d -r -N -- FL/Enumerations.H FL/Enumerations.H
--- FL/Enumerations.H	2013-04-02 22:47:57.000000000 +0600
+++ FL/Enumerations.H	2013-12-21 17:32:42.228245202 +0600
@@ -520,6 +520,18 @@
   _FL_GTK_THIN_DOWN_FRAME,	///< gtk+ version of FL_THIN_DOWN_FRAME
   _FL_GTK_ROUND_UP_BOX,		///< gtk+ version of FL_ROUND_UP_BOX
   _FL_GTK_ROUND_DOWN_BOX,	///< gtk+ version of FL_ROUND_DOWN_BOX
+  _FL_OXY_UP_BOX,
+  _FL_OXY_DOWN_BOX,
+  _FL_OXY_UP_FRAME,
+  _FL_OXY_DOWN_FRAME,
+  _FL_OXY_THIN_UP_BOX,
+  _FL_OXY_THIN_DOWN_BOX,
+  _FL_OXY_THIN_UP_FRAME,
+  _FL_OXY_THIN_DOWN_FRAME,
+  _FL_OXY_ROUND_UP_BOX,
+  _FL_OXY_ROUND_DOWN_BOX,
+  _FL_OXY_BUTTON_UP_BOX,
+  _FL_OXY_BUTTON_DOWN_BOX,
   FL_FREE_BOXTYPE		///< the first free box type for creation of new box types
 };
 extern FL_EXPORT Fl_Boxtype fl_define_FL_ROUND_UP_BOX();
@@ -566,6 +578,20 @@
 #define FL_GTK_ROUND_UP_BOX (Fl_Boxtype)(fl_define_FL_GTK_UP_BOX()+8)
 #define FL_GTK_ROUND_DOWN_BOX (Fl_Boxtype)(fl_define_FL_GTK_UP_BOX()+9)
 
+extern FL_EXPORT Fl_Boxtype fl_define_FL_OXY_UP_BOX();
+#define FL_OXY_UP_BOX fl_define_FL_OXY_UP_BOX()
+#define FL_OXY_DOWN_BOX (Fl_Boxtype)(fl_define_FL_OXY_UP_BOX()+1)
+#define FL_OXY_UP_FRAME (Fl_Boxtype)(fl_define_FL_OXY_UP_BOX()+2)
+#define FL_OXY_DOWN_FRAME (Fl_Boxtype)(fl_define_FL_OXY_UP_BOX()+3)
+#define FL_OXY_THIN_UP_BOX (Fl_Boxtype)(fl_define_FL_OXY_UP_BOX()+4)
+#define FL_OXY_THIN_DOWN_BOX (Fl_Boxtype)(fl_define_FL_OXY_UP_BOX()+5)
+#define FL_OXY_THIN_UP_FRAME (Fl_Boxtype)(fl_define_FL_OXY_UP_BOX()+6)
+#define FL_OXY_THIN_DOWN_FRAME (Fl_Boxtype)(fl_define_FL_OXY_UP_BOX()+7)
+#define FL_OXY_ROUND_UP_BOX (Fl_Boxtype)(fl_define_FL_OXY_UP_BOX()+8)
+#define FL_OXY_ROUND_DOWN_BOX (Fl_Boxtype)(fl_define_FL_OXY_UP_BOX()+9)
+#define FL_OXY_BUTTON_UP_BOX (Fl_Boxtype)(fl_define_FL_OXY_UP_BOX()+10)
+#define FL_OXY_BUTTON_DOWN_BOX (Fl_Boxtype)(fl_define_FL_OXY_UP_BOX()+11)
+
 // conversions of box types to other boxtypes:
 /**
   Get the filled version of a frame.
diff -U 3 -H -d -r -N -- FL/Fl_Calendar.H FL/Fl_Calendar.H
--- FL/Fl_Calendar.H	1970-01-01 05:00:00.000000000 +0500
+++ FL/Fl_Calendar.H	2013-12-21 09:51:00.323448120 +0600
@@ -0,0 +1,201 @@
+// Fl_Calendar (written by "Dmitrij K" <kdiman at live dot ru>) for the Fast Light Tool Kit (FLTK).
+//  license:   http://www.fltk.org/COPYING.php
+// NOTE : dear users, if you will using icons in Fl_Calendar_Prefs by defaulf, then you must to link on authors of icons in your apps (somewhere help->about->third_side_of_software) - the author has web site is http://pc.de/icons/#Cologne
+
+#ifndef Fl_Calendar_H
+#define Fl_Calendar_H
+
+#include <FL/Fl_Calendar_Prefs.H>
+#include <FL/Fl_Clock_Spinner.H>
+#include <FL/Fl_Box.H>
+#include <FL/Fl_Choice.H>
+#include <FL/Fl_Spinner.H>
+#include <FL/Fl_Double_Window.H>
+#include <FL/Fl_Menu_Window.H>
+#include <FL/Fl_Menu_Button.H>
+#include <time.h>
+
+
+// year has ~ 52.17 weeks
+class FL_EXPORT Fl_Calendar : public Fl_Menu_Window {
+protected:
+ struct tm _tm; // selected date
+ time_t _ts; // selected date
+ Fl_Button *_sel; // selected dayweek button
+ int _year, _mon, _mday; // for current date
+ 
+ Fl_Box *_header; // Header box with word's `Calendar' (you can change it in _prefs, see Fl_Calendar_Prefs)
+ 
+ Fl_Box *_icon;
+ Fl_Button *_iconaccept;
+ Fl_Button *_iconcancel;
+ Fl_Button *_iconreset;
+ Fl_Button *_iconupdate;
+ 
+ Fl_Nav_Repeat_Button *_left_btn, *_right_btn;
+ 
+ Fl_Choice *_months;
+ Fl_Spinner *_years; // [0-3000]
+ 
+ Fl_Box *_nmdays[7];
+ Fl_Box *_nweeks[6];
+ Fl_Button *_days[42];
+ char _sdays[42]; // values for this array (it linked with `_days' are buttons): `-1' - day for prev month; `0' - day for current month; `1' - day for next month
+ 
+ Fl_Spinner *_weeks; // [1-52]
+ Fl_Clock_Spinner *_clocks;
+ 
+ Fl_Calendar_Prefs _prefs;
+ 
+ int calc_height();
+ int calc_width();
+ 
+ bool _cach; // flag for close after changed date/time(change by double click); default is true
+ bool _rdo; // flag for edit time/date; default is false
+ 
+ void select(int index, bool sel);
+public:
+ 
+ Fl_Calendar(int X,int Y,int W,int H);
+ int handle(int e);
+ 
+ // hide window after changed date by double click or by click on accept button
+ void close_after_change(bool f){ _cach = f; }
+ bool close_after_change(){ return _cach; }
+ 
+ void readonly(bool f);
+ bool readonly(){ return _rdo; }
+ 
+ void activate();
+ void deactivate();
+ 
+ void resize(int X,int Y,int W,int H){ Fl_Menu_Window::resize(X, Y, w(), h()); }
+ 
+ // if p is NULL then redrawing current prefs;
+ void preferences(Fl_Calendar_Prefs *p);
+ Fl_Calendar_Prefs *preferences(){ return &_prefs; }
+ 
+ 
+ // set current local time
+ void set_now();
+ // `-1' - for old values; mday - [1-31]; mon - [0-11]; year - [0-9]{1,4}
+ // example set `5 May 2000 00:20:05': set(5, 04, 2000, 0, 20, 5);
+ void set(int mday, int mon=-1, int year=-1, int hour=-1, int min=-1, int sec=-1);
+ void set(bool utc, time_t t);
+ void set(struct tm *tm);
+ // see man(3):strptime for next function
+ void set(const char* str, const char *fmt);
+ 
+ // get time for selected date in the calendar, if `tm' is not NULL then to there will puts info too
+ time_t get(bool utc = true, struct tm *tm = NULL);
+ // get time to cstring `out' by format `fmt' ; see man(3):strftime
+ int get(const char *fmt, char *out, int szout);
+ 
+ 
+ /// Time functions has `struct tm' presentation:
+ static int get_nweek(int year, int yday, int mon, int mday, int wday); // return number of week
+ static int get_nweek_gm(const time_t target); // return number of week
+ static int get_nweek_local(const time_t target); // return number of week
+ static int get_nweek(struct tm *t); // return number of week
+ static int get_ndays(int year, int mon); // return number days
+ // ending `_pm' - for previous month, `_nm' is for next month relatively `mon'
+ static int get_ndays_pm(int year, int mon); // return number days
+ static int get_ndays_nm(int year, int mon); // return number days
+ static int get_wday(int year, int mon, int mday); // return number of day in the week[0-6]
+ static int get_yday(int year, int mon, int mday); // return number of days in `year'
+ // check `year' for leap (normal presentation: 2013, 2000)
+ static int is_leap_year(int year);
+ // convert wday from `struct tm' presentation into normal
+ static int normal_wday(int _i);
+ // convert wday from normal presentation into `struct tm' 
+ static int base_wday(int _i);
+ #ifdef _WIN32
+ // portable version of this functions for WINDOWS, see man(3):timegm
+ static time_t timegm(struct tm *tm);
+ static time_t timelocal(struct tm *tm);
+ #endif
+ 
+ 
+ /// Functions for Fl_Calendar_Prefs munipulations:
+ Fl_Font font_header(){ return _prefs._fonts[0]; }
+ Fl_Fontsize font_header_size(){ return _prefs._size_fonts[0]; }
+ int font_header_attrs(){ return _prefs._attr_fonts[0]; }
+ void font_header(Fl_Font fn, Fl_Fontsize sz=14, bool bold=false, bool italic=false){
+  set_font(0, fn, sz, bold, italic);
+ }
+ void font_header(const char *name, Fl_Fontsize sz=14, bool bold=false, bool italic=false){
+  set_font(0, name, sz, bold, italic);
+ }
+ 
+ Fl_Font font_months(){ return _prefs._fonts[1]; }
+ Fl_Fontsize font_months_size(){ return _prefs._size_fonts[1]; }
+ int font_months_attrs(){ return _prefs._attr_fonts[1]; }
+ void font_months(Fl_Font fn, Fl_Fontsize sz=14, bool bold=false, bool italic=false){
+  set_font(1, fn, sz, bold, italic);
+ }
+ void font_months(const char *name, Fl_Fontsize sz=14, bool bold=false, bool italic=false){
+  set_font(1, name, sz, bold, italic);
+ }
+ 
+ Fl_Font font_days(){ return _prefs._fonts[2]; }
+ Fl_Fontsize font_days_size(){ return _prefs._size_fonts[2]; }
+ int font_days_attrs(){ return _prefs._attr_fonts[2]; }
+ void font_days(Fl_Font fn, Fl_Fontsize sz=12, bool bold=false, bool italic=false){
+  set_font(2, fn, sz, bold, italic);
+ }
+ void font_days(const char *name, Fl_Fontsize sz=12, bool bold=false, bool italic=false){
+  set_font(2, name, sz, bold, italic);
+ }
+ 
+ 
+ void set_font(int index, Fl_Font fn, Fl_Fontsize sz=14, bool bold=false, bool italic=false){
+  if(index < 0 || index >= 3){ return ; }
+  int attrs = 0; if(bold){ attrs |= FL_BOLD; } if(italic){ attrs |= FL_ITALIC; }
+  _prefs._fonts[index] = fn;
+  _prefs._attr_fonts[index] = attrs;
+  _prefs._size_fonts[index] = sz;
+  preferences(NULL);
+ }
+ 
+ void set_font(int index, const char *name, Fl_Fontsize sz=14, bool bold=false, bool italic=false){
+  if(index < 0 || index >= 3){ return ; }
+  int attrs = 0; if(bold){ attrs |= FL_BOLD; } if(italic){ attrs |= FL_ITALIC; }
+  int ifont = font_index(name, attrs);
+  if(ifont < 0){ return; }
+  _prefs._fonts[index] = ifont;
+  _prefs._attr_fonts[index] = attrs;
+  _prefs._size_fonts[index] = sz;
+  preferences(NULL);
+ }
+ 
+ int font_index(const char *name, int attrs=0){
+  int r = -1;
+  if(name == NULL){ return r; }
+  int lfonts = Fl::set_fonts("*");
+  int type = 0;
+  const char *fn = NULL;
+  for(int _i = 0; _i < lfonts; _i++){
+   fn = Fl::get_font_name((Fl_Font)_i, &type);
+   if(!strcasecmp(name, fn) && type == attrs){
+    r = _i; break;
+   }
+  }
+  return r;
+ }
+ 
+ 
+ 
+private:
+ // callbacks
+ static void year_cb(Fl_Spinner* w, Fl_Calendar *a);
+ static void month_cb(Fl_Choice* w, Fl_Calendar *a);
+ static void month_cb2(Fl_Nav_Repeat_Button* w, Fl_Calendar *a);
+ static void week_cb(Fl_Spinner* w, Fl_Calendar *a);
+ static void clock_cb(Fl_Clock_Spinner* w, Fl_Calendar *a);
+ static void button_cb(Fl_Button* w, Fl_Calendar *a);
+ 
+}; // Fl_Calendar
+
+
+
+#endif
diff -U 3 -H -d -r -N -- FL/Fl_Calendar_Prefs.H FL/Fl_Calendar_Prefs.H
--- FL/Fl_Calendar_Prefs.H	1970-01-01 05:00:00.000000000 +0500
+++ FL/Fl_Calendar_Prefs.H	2013-12-21 09:51:00.330448119 +0600
@@ -0,0 +1,48 @@
+// Fl_Calendar_Prefs (written by "Dmitrij K" <kdiman at live dot ru>) for the Fast Light Tool Kit (FLTK).
+//  license:   http://www.fltk.org/COPYING.php
+// NOTE :  icons were taken from http://pc.de/icons/pc.de-cologne-icon-pack.zip , you can use its and for free & for commerce apps, but you should 
+// NOTE : dear users, if you will using icons in Fl_Calendar_Prefs by default, then you must to link on authors of icons in your apps (somewhere help->about->third_side_of_software) - the author has web site is http://pc.de/icons/#Cologne
+
+#ifndef Fl_Calendar_Prefs_H
+#define Fl_Calendar_Prefs_H
+
+#include <FL/Fl.H>
+#include <FL/Fl_PNG_Image.H>
+
+// TODO : needs in the Fl_PNG_Image class to add method set_image_from_buffer(buff, lenbuff), for users has possibility to change icons for calendar !
+class FL_EXPORT Fl_Calendar_Prefs {
+public:
+ Fl_Calendar_Prefs();
+ ~Fl_Calendar_Prefs();
+ 
+ Fl_PNG_Image _icon; // icon for header (drawing on left side from label has word in `_header')
+ Fl_PNG_Image _iconupdate; // icon for update to current local time and set it
+ Fl_PNG_Image _iconreset; // icon for reset to current date (drawing in left-bottom corner)
+ Fl_PNG_Image _iconaccept; // icon for accept current selected date as base
+ Fl_PNG_Image _iconcancel; // icon for closebutton (drawing on right side from the label)
+ 
+ // NOTE : deimages are auto-generation from normal icons
+ Fl_PNG_Image _deicon, _deiconcancel, _deiconreset, _deiconaccept, _deiconupdate;
+ 
+ // Indexes: 0-_iconupdate, 1-_iconreset, 2-_iconaccept, 3-_iconcancel
+ char _icontooltips[4][32];
+ 
+ char _header[32]; // header label `Calendar' - is the lable
+ char _months[12][32]; // November, September ...
+ char _days[7][32]; // short notations for months: _days[0]="Sun", _days[1]="Mon" ...
+ 
+ // Indexes: 0 - inactive color; 1 - base color; 2 - selection color;
+ Fl_Color _headercolor[3]; // colors of _header
+ Fl_Color _monthscolor[3]; // colors of months
+ Fl_Color _dayscolor[3]; // colors of days
+ 
+ // Indexes: 0 - for _header; 1 - for _months & num year; 2 - for _days;
+ Fl_Fontsize _size_fonts[3];
+ int _attr_fonts[3];
+ char _name_fonts[3][36];
+ Fl_Font _fonts[3];
+ 
+};
+
+
+#endif
diff -U 3 -H -d -r -N -- FL/Fl_Clock_Input.H FL/Fl_Clock_Input.H
--- FL/Fl_Clock_Input.H	1970-01-01 05:00:00.000000000 +0500
+++ FL/Fl_Clock_Input.H	2013-12-21 09:51:00.330448119 +0600
@@ -0,0 +1,36 @@
+// Fl_Clock_Input (written by "Dmitrij K" <kdiman at live dot ru>) for the Fast Light Tool Kit (FLTK).
+//  license:   http://www.fltk.org/COPYING.php
+
+#ifndef Fl_Clock_Input_H
+#define Fl_Clock_Input_H
+
+#include <FL/Fl_Input.H>
+
+class FL_EXPORT Fl_Clock_Input : public Fl_Input {
+public:
+ Fl_Clock_Input(int X,int Y,int W,int H,const char*L=0);
+ virtual int handle(int e);
+ 
+ void incr();
+ void decr();
+ 
+ void get_values(int &hour, int &minutes);
+ void set_values(int hour, int minute, int pos = -1);
+ 
+ void hours(int hour);
+ int hours(){ return _hours; }
+ 
+ void minutes(int minute);
+ int minutes(){ return _minutes; }
+ 
+ void check_value();
+ void update(int pos = -1);
+ 
+protected:
+ int _lp; // last position (for to know what to increment)
+ int _hours;
+ int _minutes;
+};
+
+
+#endif
diff -U 3 -H -d -r -N -- FL/Fl_Clock_Spinner.H FL/Fl_Clock_Spinner.H
--- FL/Fl_Clock_Spinner.H	1970-01-01 05:00:00.000000000 +0500
+++ FL/Fl_Clock_Spinner.H	2013-12-21 09:51:00.331448120 +0600
@@ -0,0 +1,52 @@
+// Fl_Clock_Spinner (written by "Dmitrij K" <kdiman at live dot ru>) for the Fast Light Tool Kit (FLTK).
+//  license:   http://www.fltk.org/COPYING.php
+
+#ifndef Fl_Clock_Spinner_H
+#define Fl_Clock_Spinner_H
+
+#include <FL/Fl_Clock_Input.H>
+#include <FL/Fl_Nav_Button.H>
+#include <FL/Fl_Group.H>
+
+// values for type():
+#define FL_NORMAL_CLOCK_SPINNER   0
+#define FL_READONLY_CLOCK_SPINNER   1
+
+#define BUTTON_ARROW_WIDTH 11
+
+
+// TODO : needs add support for seconds in a future (with )
+class FL_EXPORT Fl_Clock_Spinner : public Fl_Group {
+protected:
+ Fl_Clock_Input _input;
+ Fl_Nav_Repeat_Button _up, _down;
+public:
+ 
+ Fl_Clock_Spinner(int X,int Y,int W,int H,const char*L=0);
+ 
+ void resize(int X,int Y,int W,int H);
+ void type(int t);
+ 
+ void readonly(bool f){
+  if(f){ type(FL_READONLY_CLOCK_SPINNER); }
+  else { type(FL_NORMAL_CLOCK_SPINNER); }
+ }
+ 
+ bool readonly(){ return (Fl_Group::type() == FL_READONLY_CLOCK_SPINNER); }
+ 
+ void set_values(int hour, int minute){ _input.set_values(hour, minute); } // set
+ void get_values(int &hour, int &minutes){ _input.get_values((int&)hour, (int&)minutes); } // get
+ 
+ void hours(int hour){ _input.hours(hour); } // set
+ int hours(){ return _input.hours(); } // get
+ 
+ void minutes(int minute){ _input.minutes(minute); } // set
+ int minutes(){ return _input.minutes(); } // get
+ 
+ 
+ virtual int handle(int e);
+ static void sb_cb(Fl_Widget *w, Fl_Clock_Spinner *sb);
+};
+
+
+#endif
diff -U 3 -H -d -r -N -- FL/Fl_Input_Choice.H FL/Fl_Input_Choice.H
--- FL/Fl_Input_Choice.H	2012-12-09 23:45:24.000000000 +0600
+++ FL/Fl_Input_Choice.H	2013-12-21 09:51:00.331448120 +0600
@@ -1,5 +1,5 @@
 //
-// "$Id: Fl_Input_Choice.H 9740 2012-12-09 17:45:24Z manolo $"
+// "$Id: Fl_Input_Choice.H 9203 2011-12-08 18:18:51Z greg.ercolano $"
 //
 // An input/chooser widget.
 //            ______________  ____
@@ -9,6 +9,7 @@
 //
 // Copyright 1998-2010 by Bill Spitzak and others.
 // Copyright 2004 by Greg Ercolano.
+// 2013 by Dmitrij K was made adapting for theme Oxy
 //
 // This library is free software. Distribution and use rights are outlined in
 // the file "COPYING" which should have been included with this file.  If this
@@ -27,196 +28,97 @@
 #ifndef Fl_Input_Choice_H
 #define Fl_Input_Choice_H
 
-#include <FL/Fl.H>
-#include <FL/Fl_Group.H>
+#include <FL/Fl_Menu_.H>
 #include <FL/Fl_Input.H>
-#include <FL/Fl_Menu_Button.H>
-#include <FL/fl_draw.H>
-#include <string.h>
-
-/**
-  A combination of the input widget and a menu button.
-
-  \image html input_choice.jpg
-  \image latex input_choice.jpg "Fl_Input_Choice widget" width=6cm
-
-  The user can either type into the input area, or use the
-  menu button chooser on the right to choose an item which loads
-  the input area with the selected text.
-  <P>
-  The application can directly access both the internal Fl_Input 
-  and Fl_Menu_Button widgets respectively using the input() and menubutton()
-  accessor methods.
-*/
-class FL_EXPORT Fl_Input_Choice : public Fl_Group {
-  // Private class to handle slightly 'special' behavior of menu button
-  class InputMenuButton : public Fl_Menu_Button {
-    void draw() {
-      draw_box(FL_UP_BOX, color());
-      fl_color(active_r() ? labelcolor() : fl_inactive(labelcolor()));
-      int xc = x()+w()/2, yc=y()+h()/2;
-      fl_polygon(xc-5,yc-3,xc+5,yc-3,xc,yc+3);
-      if (Fl::focus() == this) draw_focus();
-    }
-  public:
-    InputMenuButton(int X,int Y,int W,int H,const char*L=0) : 
-	Fl_Menu_Button(X, Y, W, H, L) { box(FL_UP_BOX); }
-  };
-
-  Fl_Input *inp_;
-  InputMenuButton *menu_;
-
-  static void menu_cb(Fl_Widget*, void *data) { 
-    Fl_Input_Choice *o=(Fl_Input_Choice *)data;
-    Fl_Widget_Tracker wp(o);
-    const Fl_Menu_Item *item = o->menubutton()->mvalue();
-    if (item && item->flags & (FL_SUBMENU|FL_SUBMENU_POINTER)) return;	// ignore submenus
-    if (!strcmp(o->inp_->value(), o->menu_->text()))
-    {
-      o->Fl_Widget::clear_changed();
-      if (o->when() & FL_WHEN_NOT_CHANGED)
-	o->do_callback();
-    }
-    else
-    {
-      o->inp_->value(o->menu_->text());
-      o->inp_->set_changed();
-      o->Fl_Widget::set_changed();
-      if (o->when() & (FL_WHEN_CHANGED|FL_WHEN_RELEASE))
-	o->do_callback();
-    }
-    
-    if (wp.deleted()) return;
-
-    if (o->callback() != default_callback)
-    {
-      o->Fl_Widget::clear_changed();
-      o->inp_->clear_changed();
-    }
-  }
-
-  static void inp_cb(Fl_Widget*, void *data) { 
-    Fl_Input_Choice *o=(Fl_Input_Choice *)data;
-    Fl_Widget_Tracker wp(o);
-    if (o->inp_->changed()) {
-      o->Fl_Widget::set_changed();
-      if (o->when() & (FL_WHEN_CHANGED|FL_WHEN_RELEASE))
-	o->do_callback();
-    } else {
-      o->Fl_Widget::clear_changed();
-      if (o->when() & FL_WHEN_NOT_CHANGED)
-	o->do_callback();
-    }
-    
-    if (wp.deleted()) return;
-
-    if (o->callback() != default_callback)
-      o->Fl_Widget::clear_changed();
-  }
-
-  // Custom resize behavior -- input stretches, menu button doesn't
-  inline int inp_x() { return(x() + Fl::box_dx(box())); }
-  inline int inp_y() { return(y() + Fl::box_dy(box())); }
-  inline int inp_w() { return(w() - Fl::box_dw(box()) - 20); }
-  inline int inp_h() { return(h() - Fl::box_dh(box())); }
+#include <FL/Fl_Nav_Button.H>
 
-  inline int menu_x() { return(x() + w() - 20 - Fl::box_dx(box())); }
-  inline int menu_y() { return(y() + Fl::box_dy(box())); }
-  inline int menu_w() { return(20); }
-  inline int menu_h() { return(h() - Fl::box_dh(box())); }
 
-public:
-  /**
-    Creates a new Fl_Input_Choice widget using the given position, size,
-    and label string.
-    Inherited destructor destroys the widget and any values associated with it.
-  */
-  Fl_Input_Choice(int X,int Y,int W,int H,const char*L=0);
+class Fl_Input_Choice: public Fl_Menu_ {
+ Fl_Input input_;
+ Fl_Nav_Button button_;
+ public:
+ 
+  Fl_Input_Choice(int X, int Y, int W, int H, const char *L=0);
   
-  /** Adds an item to the menu.
-   You can access the more complex Fl_Menu_Button::add() methods 
-   (setting callbacks, userdata, etc), via menubutton(). Example:
-   \code
-   Fl_Input_Choice *choice = new Fl_Input_Choice(100,10,120,25,"Fonts");
-   Fl_Menu_Button *mb = choice->menubutton();             // use Fl_Input_Choice's Fl_Menu_Button
-   mb->add("Helvetica", 0, MyFont_CB,     (void*)mydata); // use Fl_Menu_Button's add() methods
-   mb->add("Courier",   0, MyFont_CB,     (void*)mydata);
-   mb->add("More..",    0, FontDialog_CB, (void*)mydata);
-   \endcode
-   */
-  void add(const char *s) { menu_->add(s);  }
-  /** Returns the combined changed() state of the input and menu button widget. */
-  int changed() const { return inp_->changed() | Fl_Widget::changed(); }
-  /** Clears the changed() state of both input and menu button widgets. */
-  void clear_changed() { 
-    inp_->clear_changed();
-    Fl_Widget::clear_changed();
-  }
-  /** Sets the changed() state of both input and menu button widgets
-   to the specfied value.*/
-  void set_changed() { 
-    inp_->set_changed();
-    // no need to call Fl_Widget::set_changed()
-  }
-  /** Removes all items from the menu. */
-  void clear() { menu_->clear(); }
-  /** Gets the box type of the menu button */
-  Fl_Boxtype down_box() const { return (menu_->down_box()); }
-  /** Sets the box type of the menu button */
-  void down_box(Fl_Boxtype b) { menu_->down_box(b); }
-  /** Gets the Fl_Menu_Item array used for the menu. */
-  const Fl_Menu_Item *menu() { return (menu_->menu()); }
-  /** Sets the Fl_Menu_Item array used for the menu. */
-  void menu(const Fl_Menu_Item *m) { menu_->menu(m); }
-  void resize(int X, int Y, int W, int H) {
-    Fl_Group::resize(X,Y,W,H);
-    inp_->resize(inp_x(), inp_y(), inp_w(), inp_h());
-    menu_->resize(menu_x(), menu_y(), menu_w(), menu_h());
+  inline virtual void draw(){
+   int dx = Fl::box_dx(box()), dy = Fl::box_dy(box()), dw = Fl::box_dw(box()), dh = Fl::box_dh(box());
+   int X = x(), Y = y(), W = w(), H = h();
+   fl_push_clip(X,Y,W,H);
+   draw_box(box(), color());
+   input_.damage_resize(X+dx, Y+dy, W-dw-18, H-dh);
+   button_.damage_resize(X+W-18-1, Y+dy/2, 18, H-dh/2);
+   fl_pop_clip();
   }
-  /// Gets the Fl_Input text field's text color.
-  Fl_Color textcolor() const { return (inp_->textcolor());}
-  /// Sets the Fl_Input text field's text color to \p c.
-  void textcolor(Fl_Color c) { inp_->textcolor(c);}
-  /// Gets the Fl_Input text field's font style.
-  Fl_Font textfont() const { return (inp_->textfont());}
-  /// Sets the Fl_Input text field's font style to \p f.
-  void textfont(Fl_Font f) { inp_->textfont(f);}
-  /// Gets the Fl_Input text field's font size
-  Fl_Fontsize textsize() const { return (inp_->textsize()); }
-  /// Sets the Fl_Input text field's font size to \p s.
-  void textsize(Fl_Fontsize s) { inp_->textsize(s); }
-  /// Returns the Fl_Input text field's current contents.
-  const char* value() const { return (inp_->value()); }
-  /** Sets the Fl_Input text field's contents to \p val.
-   Does not affect the menu selection.*/
-  void value(const char *val) { inp_->value(val); }
-  /** Chooses item# \p val in the menu, and sets the Fl_Input text field
-   to that value. Any previous text is cleared.*/
-  void value(int val) {
-    menu_->value(val);
-    inp_->value(menu_->text(val));
+  
+  inline int changed() const { return input_.changed() | Fl_Menu_::changed(); }
+  inline void clear_changed() { input_.clear_changed(); Fl_Menu_::clear_changed(); }
+  inline void set_changed() { input_.set_changed(); }
+  
+  inline Fl_Input* input(){ return &input_; }
+  inline Fl_Nav_Button* button(){ return &button_; }
+  
+  inline void add(const char *l){ Fl_Menu_::add(l); }
+  inline void clear() { Fl_Menu_::clear(); }
+  inline const char* value() const { return (input_.value()); }
+  inline void value(const char *val) { input_.value(val); }
+  inline void value(int val) { Fl_Menu_::value(val); input_.value(Fl_Menu_::text(val)); }
+  
+ public:
+  
+  static void input_cb(Fl_Widget *w, void *d){
+   Fl_Input_Choice *o=(Fl_Input_Choice *)d;
+   Fl_Widget_Tracker wp(o);
+   
+   if (o->input()->changed()) {
+    o->Fl_Widget::set_changed();
+    if (o->when() & (FL_WHEN_CHANGED|FL_WHEN_RELEASE)){ o->do_callback(); }
+   }
+   
+   else {
+    o->Fl_Widget::clear_changed();
+    if (o->when() & FL_WHEN_NOT_CHANGED){ o->do_callback(); }
+   }
+   
+   if (wp.deleted()){ return; }
+   if (o->callback() != default_callback){ o->Fl_Widget::clear_changed(); }
   }
-  /** Returns a pointer to the internal Fl_Menu_Button widget.
-   This can be used to access any of the methods of the menu button, e.g.
-   \code
-   Fl_Input_Choice *choice = new Fl_Input_Choice(100,10,120,25,"Choice:");
-   [..]
-   // Print all the items in the choice menu
-   for ( int t=0; t<choice->menubutton()->size(); t++ ) {
-       const Fl_Menu_Item &item = choice->menubutton()->menu()[t];
-       printf("item %d -- label=%s\n", t, item.label() ? item.label() : "(Null)");
+  
+  static void menu_cb(Fl_Widget *w, void *d) {
+   Fl_Input_Choice *o=(Fl_Input_Choice *)d;
+   Fl_Widget_Tracker wp(o);
+   const Fl_Menu_Item *item = NULL;
+   
+   if (Fl::scheme() || fl_contrast(o->textcolor(), FL_BACKGROUND2_COLOR) != o->textcolor()) {
+    item = o->menu()->pulldown(o->x(),o-> y(), o->w(), o->h(), 0, o);
    }
-   \endcode
-  */
-  Fl_Menu_Button *menubutton() { return menu_; }
-  /** Returns a pointer to the internal Fl_Input widget.
-   This can be used to directly access all of the Fl_Input widget's
-   methods.*/
-  Fl_Input *input() { return inp_; }
+   
+   else {
+    Fl_Color c = o->color();
+    o->color(FL_BACKGROUND2_COLOR);
+    item = o->menu()->pulldown(o->x(),o-> y(), o->w(), o->h(), 0, o);
+    o->color(c);
+   }
+   
+   if (!item){ return; }
+   if (item->flags & (FL_SUBMENU|FL_SUBMENU_POINTER)){ return; } // ignore submenus
+   if ( !strcmp(o->input()->value(), item->label())) {
+    o->Fl_Widget::clear_changed();
+    if (o->when() & FL_WHEN_NOT_CHANGED){ o->do_callback(); }
+   }
+   
+   else {
+    o->input()->value(item->label());
+    o->input()->set_changed();
+    o->Fl_Widget::set_changed();
+    if (o->when() & (FL_WHEN_CHANGED|FL_WHEN_RELEASE)){ o->do_callback(); }
+   }
+   if (wp.deleted()){ return; }
+   if (o->callback() != default_callback){
+    o->Fl_Widget::clear_changed();
+    o->input()->clear_changed();
+   }
+  }
+  
 };
 
-#endif // !Fl_Input_Choice_H
-
-//
-// End of "$Id: Fl_Input_Choice.H 9740 2012-12-09 17:45:24Z manolo $".
-//
+#endif
